searchNodes=[{"doc":"This module is used to retrieve assorted pieces of configuration from a release's build environment. Which build is this? Who built this release? When was this built? What was the Git SHA for this build? Usage Make sure that you capture all elements you need to a module attribute - e.g. module Foo do import SayCheezEx , only : [ cheez! : 1 ] # e.g. &quot;v 0.1.5/d9a87c3 137 on server.local&quot; @version cheez! ( &quot;v {:project_version}/{:git_commit_id} {:build_number} on {:build_on}&quot; ) ... end Data gathering must be done at compile time and will simply create a string once and for all that matches your informational need. This can be done in multiple ways: You can call the cheez!/1 or cheez/1 functions with a format string, as described in their docs You can call info/1 and get_env/1 to extract the specific parameters you need. See info/1 for list of allowed attributes, or all/0 for a map with all pre-defined attributes. Graphs What is better than Elixir's own documentation? adding graphs to it, and having them embedded in your documentation. To try them, use: module Foo do import SayCheezEx , only : [ uml : 1 , graphviz : 1 ] @moduledoc &quot;&quot;&quot; Here goes a Graphviz graph: \#{ graphviz ( &quot;digraph { Sup -&gt; GenServ }&quot; ) } Here a PlantUML graph: \#{ uml ( &quot;&quot;&quot; Bob -&gt; Alice : I do love UML in documentation Alice -&gt; Bob : I love it too! &quot;&quot;&quot; ) } &quot;&quot;&quot; ... end See for yourself some examples at: graphviz/1 uml/1 Graphs are cached under _build/img_cache so a full render happens only when they change.","ref":"SayCheezEx.html","title":"SayCheezEx","type":"module"},{"doc":"Dumps a map of all known build/env configuration keys for this environment. If you want a map of only some elements, see all/1 . An example output might be: %{ build_at : &quot;230411.1528&quot; , build_at_day : &quot;2023-04-11&quot; , build_at_full : &quot;2023-04-11.15:28:47&quot; , build_by : &quot;lenz&quot; , build_number : &quot;87&quot; , build_on : &quot;Lenzs-MacBook-Pro.local&quot; , build_mix_env : &quot;dev&quot; , git_all : &quot;b204919/230411.1509&quot; , git_commit_id : &quot;b204919&quot; , git_commit_id_full : &quot;b2049190312ef810875476398978c2b0387251d3&quot; , git_date : &quot;2023-04-11.15:09:50&quot; , git_date_compact : &quot;230411.1509&quot; , git_last_committer : &quot;Lenz&quot; , project_full_version : &quot;0.2.1/b204919/230411.1509&quot; , project_name : &quot;SayCheezEx&quot; , project_version : &quot;0.2.2&quot; , sysinfo_arch : &quot;aarch64-apple-darwin22.3.0&quot; , sysinfo_beam : &quot;BEAM jit 13.2&quot; , sysinfo_c_compiler : &quot;gnuc 4.2.1&quot; , sysinfo_compat : &quot;25&quot; , sysinfo_driver : &quot;3.3&quot; , sysinfo_nif : &quot;2.16&quot; , sysinfo_ptr : &quot;64bit&quot; , sysinfo_word : &quot;64bit&quot; , system : &quot;1.14.3/OTP25&quot; , system_elixir : &quot;1.14.3&quot; , system_otp : &quot;25&quot; , ... } but the right place to check all properties and their meaning is info/1 .","ref":"SayCheezEx.html#all/0","title":"SayCheezEx.all/0","type":"function"},{"doc":"Prints a map of only some elements. If you want a map of all elements, see all/0 .","ref":"SayCheezEx.html#all/1","title":"SayCheezEx.all/1","type":"function"},{"doc":"Captures the environment from a definition string. Same as cheez!/1 but it does not print the captured string.","ref":"SayCheezEx.html#cheez/1","title":"SayCheezEx.cheez/1","type":"function"},{"doc":"Captures the environment from a definition string, and prints it out so it is shown in the compile logs. Usage: &gt; cheez! ( &quot;v {:project_version}/{:git_commit_id} {:build_number} on {:build_on}&quot; ) &quot;v 0.1.5/d9a87c3 137 on server.local&quot; Definition strings This function will interpolate attributes set between brackets, with the following rules: {:project_version} is an info tag. These is a long list of those - see all/0 . {$HOST} is an environment variable - in this case, HOST {=HELLO} is a default value, in this case the literal string &quot;HELLO&quot; If multiple attributes are specified in a comma-separated string, they all are expanded, and the first one that is defined will be output. So e.g. {$FOO,$BAR,=BAZ} will first try to interpolate the variable FOO; if that is undefined, it will try BAR, and if that too is undefined, it will output &quot;BAZ&quot; (that is always defined) As it is quite a common thing to include a module name in the string as it appears in the MODULE attribute, and that will print out the module with an &quot;Elixir&quot; prefix (e.g. module &quot;Foo.Bar&quot; will become &quot;Elixir.Foo.Bar&quot;), the &quot;Elixir&quot; prefix is stripped when found. Controlling output In general, on every capture, we would love to print out the current captured variables on STDOUT. This is quite handy for server builds, as in the build log there are the same pieces of information that the build embeds. This also gets in the way during development and testing, cluttering the output. So the default is that is printing only happens when building in the :prod environment, unless you force it on or off using the CHEEZ environment variable. So, say.... CHEEZ = 1 mix test Will print captured output (see should_print?/0 for further details). Of course this only happens when compiling classes, so when working interactively you may sometimes see the output and sometimes won't, as the compiler decides what is in need of being rebuilt. If you don't want this fuction to print out the captured environment, just use cheez/1 .","ref":"SayCheezEx.html#cheez!/1","title":"SayCheezEx.cheez!/1","type":"function"},{"doc":"Creates a date out of an ISO date. We need to do this instead of giving git format options, as date formatting is not supported well by ancient git versions (e.g. Centos7 still has git 1.8). So we basically break a date of the format 2023-02-15 08:50:19 +0100 into a set of tokens, and reassemble them based on a list of input tokens or constant strings.","ref":"SayCheezEx.html#date_from_iso_date/2","title":"SayCheezEx.date_from_iso_date/2","type":"function"},{"doc":"Expands a sequence of tokens into a string.","ref":"SayCheezEx.html#expand/1","title":"SayCheezEx.expand/1","type":"function"},{"doc":"Given a list of candidates, returs the first that is not unknown. If all of them are unknown, return the default.","ref":"SayCheezEx.html#first_non_empty/2","title":"SayCheezEx.first_non_empty/2","type":"function"},{"doc":"As the C compiler is formatted differently on Win and Unix, we handle both cases with a related unit test, so we can add (and test) more.","ref":"SayCheezEx.html#format_sysinfo_c_compiler/1","title":"SayCheezEx.format_sysinfo_c_compiler/1","type":"function"},{"doc":"Reads the first env variable that is not empty.","ref":"SayCheezEx.html#get_env/1","title":"SayCheezEx.get_env/1","type":"function"},{"doc":"","ref":"SayCheezEx.html#get_env_log/1","title":"SayCheezEx.get_env_log/1","type":"function"},{"doc":"Reads an ISO date from Git. See date_from_iso_date/2","ref":"SayCheezEx.html#git_iso_date/0","title":"SayCheezEx.git_iso_date/0","type":"function"},{"doc":"Runs current Git command. CWD is the root of the repo.","ref":"SayCheezEx.html#git_run/1","title":"SayCheezEx.git_run/1","type":"function"},{"doc":"Runs a local Graphviz command and embeds the resulting SVG. Sup Sup GenServ GenServ Sup&#45;&gt;GenServ OtherGenServer OtherGenServer Sup&#45;&gt;OtherGenServer Notes Requires GraphViz installed You can find full documentation of GraphViz at https://graphviz.org/ See also uml/1 .","ref":"SayCheezEx.html#graphviz/1","title":"SayCheezEx.graphviz/1","type":"function"},{"doc":"Reads a hostname.","ref":"SayCheezEx.html#hostname/0","title":"SayCheezEx.hostname/0","type":"function"},{"doc":"Gets assorted pieces of system information. Project project_name: &quot;SayCheezEx&quot; - the project will be named with an atom as :say_cheez_ex , but we return a camelized string project_version: &quot;0.1.0-dev&quot;, project_full_version: &quot;0.1.0-dev/7ea2260/230212.1425&quot;, Elixir - Erlang system: &quot;1.13.4/OTP25&quot;, system_elixir: &quot;1.13.4&quot;, system_otp: &quot;25&quot; Git git_all: &quot;7ea2260/230212.1425&quot; - a recap of commit id and date compact git_commit_id: &quot;7ea2260&quot; - the short commit-id git_commit_id_full: &quot;7ea2260895f35fc46976a2fdbc4d8faeaad09467&quot; - the full commit-id git_date: &quot;2023-02-12.14:25:47&quot; - the date if last commit git_date_compact: &quot;230212.1425&quot; - the compact date of last commit git_last_committer: &quot;Lenz&quot; - the author of last commit Build information build_at: &quot;230213.1545&quot; - a short date of when the release was built build_at_day: &quot;2023-02-13&quot; - the day a release was built build_at_full: &quot;2023-02-13.15:45:08&quot; - the exact time a release was built build_by: &quot;jenkins&quot; - the user that was running on the build server build_on: &quot;intserver03&quot; - the server the release was built on. First checks hostname then the environment variable HOST build_mix_env : the mix build environament, as a string (e.g. &quot;dev&quot; or &quot;prod&quot; ) Jenkins-specific build_number: &quot;86&quot; - the value of the BUILD_NUMBER attribute System environment sysinfo_arch : the system architecture (e.g. &quot;aarch64-apple-darwin22.3.0&quot; ) sysinfo_beam : the type of VM, whether it's a JIT or interpreter, and its version (e.g. &quot;BEAM jit 13.2&quot; ) sysinfo_banner : the &quot;welcome banner&quot; that the VM prints on startup (e.g. &quot;Erlang/OTP 25 [erts-13.2] [source] [64-bit] [smp:10:10] [ds:10:10:10] [async-threads:1] [jit]&quot; ) sysinfo_c_compiler : the system C compiler used to build the VM (e.g. &quot;gnuc 4.2.1&quot; ) sysinfo_compat : the Erlang/OTP release that the current emulator has been set to be backward compatible with (e.g. &quot;25&quot; ) sysinfo_driver : Erlang driver version used by the runtime system (e.g. &quot;3.3&quot; ) sysinfo_nif : version of the Erlang NIF interface (e.g. &quot;2.16&quot; ) sysinfo_ptr : the size of Erlang term words in bits (e.g. &quot;64bit&quot; ) sysinfo_word : the size of an emulator pointer in bits (e.g. &quot;64bit&quot; )","ref":"SayCheezEx.html#info/1","title":"SayCheezEx.info/1","type":"function"},{"doc":"We want to rewrite ELixir module names so we can remove the Elixir prefix. From &quot;{:abc,=NONE} Elixir.My.Module {:abc,=NONE}&quot; To &quot;{:abc,=NONE} My.Module {:abc,=NONE}&quot;","ref":"SayCheezEx.html#replace_elixir_modules/1","title":"SayCheezEx.replace_elixir_modules/1","type":"function"},{"doc":"Runs a command. Returns the output, only if return code is zero. Otherwise returns &quot;@unknown_entry&quot;","ref":"SayCheezEx.html#run_cmd/2","title":"SayCheezEx.run_cmd/2","type":"function"},{"doc":"When should we print on STDOUT? in environment :prod only (so for final build) unless environment variable CHEEZ is set to 1, that forces printing in all environments unless environment variable CHEEZ is set to 0, that silences printing in all environments","ref":"SayCheezEx.html#should_print?/0","title":"SayCheezEx.should_print?/0","type":"function"},{"doc":"Checks whether we should output the results of SayCheezEx on STDOUT. In a separate function for ease of testing.","ref":"SayCheezEx.html#should_print?/2","title":"SayCheezEx.should_print?/2","type":"function"},{"doc":"Tokenizes a string into a list.","ref":"SayCheezEx.html#tokenize/2","title":"SayCheezEx.tokenize/2","type":"function"},{"doc":"Breaks up a list of keywords into tuples.","ref":"SayCheezEx.html#tokenize_kws/1","title":"SayCheezEx.tokenize_kws/1","type":"function"},{"doc":"Runs a command though PlantUml, either local or on-line. This is pretty handy to document, for example, a set of GenServers and how they depend on each other: QMLive Local DB Operator 1 Operator N QML Table of Services Instance state Operator 1 Updater DynamicSupervisor Puller X Puller Y Pusher A Pusher B Cmds A Service N Application Pool Activator Logger Web acceptor Or how multiple GenServers send messages to each other and which responses/replies are used: Shared feedback actions LogFwd PBX PBX Uniloader Uniloader Puller Puller Pusher 1 Pusher 1 Commands 1 Commands 1 Pusher 2 Pusher 2 Commands 2 Commands 2 QMLive 1 QMLive 1 QMLive 2 QMLive 2 Log upload... Actions pending Check actions Any news? new command, id=123 new cmd, id=C1/P1/123 Command stored Timer wake-up Any news? \"new command, id=42\" \"new cmd, id=C2/P1/42\" 2 cmds stored And there is way more - only limited by your imagination. For example, this is a mind-map (stolen from https://www.drawio.com/blog/plantuml-mindmaps-from-text ) It ain't' half bad, right? Currently under review Onboarding and offboarding tasks Onboarding Prior to first day Contract signed Employee handbook IT equipment reserved First day Office tour Team intros Account setup First week Shadow team members Software training First month Assign projects/tasks Set goals Get team feedback Offboarding Feedback and review Exit interview Tasks/projects reassigned Handover Account deactivation/deletion IT hardware return priority meetings Tasks Last updated: May And as all of this is text-based, it plays well with your source files, version control and whatnot. Notes You can find full documentation of PlantUML and the gazillion graphs it produces at https://plantuml.com/ At the moment, all images are processed through the on-line server Nothing stops you from using the module SayCheezEx.Graphs.Plantuml to generate SVG images at runtime, not only in documentation. See also graphviz/1 .","ref":"SayCheezEx.html#uml/1","title":"SayCheezEx.uml/1","type":"function"},{"doc":"Reads information out of the Elixir / Beam environment. Set into a special module for ease of testing via mocking.","ref":"SayCheezEx.DataSource.Beam.html","title":"SayCheezEx.DataSource.Beam","type":"module"},{"doc":"Calls System.build_info() . E.g. %{ build : &quot;1.14.3 (compiled with Erlang/OTP 25)&quot; , date : &quot;2023-01-14T15:30:14Z&quot; , otp_release : &quot;25x&quot; , revision : &quot;6730d66&quot; , version : &quot;1.14.2&quot; }","ref":"SayCheezEx.DataSource.Beam.html#build_info/0","title":"SayCheezEx.DataSource.Beam.build_info/0","type":"function"},{"doc":"Calls :erlang.system_info/1 .","ref":"SayCheezEx.DataSource.Beam.html#system_info/1","title":"SayCheezEx.DataSource.Beam.system_info/1","type":"function"},{"doc":"Calls a local graphviz command and renders the graph.","ref":"SayCheezEx.Graphs.Graphviz.html","title":"SayCheezEx.Graphs.Graphviz","type":"module"},{"doc":"","ref":"SayCheezEx.Graphs.Graphviz.html#generate_content_graphviz_local/1","title":"SayCheezEx.Graphs.Graphviz.generate_content_graphviz_local/1","type":"function"},{"doc":"PlantUML has an online server, e.g. this: @startuml Bob -&gt; Alice : hello @enduml Will be translated into this: https :// www . plantuml . com / plantuml / svg / SoWkIImgAStDuNBAJrBGjLDmpCbCJbMmKiX8pSd9vt98pKi1IW80 So you don't need to have PlantUML installed.","ref":"SayCheezEx.Graphs.Plantuml.html","title":"SayCheezEx.Graphs.Plantuml","type":"module"},{"doc":"","ref":"SayCheezEx.Graphs.Plantuml.html#as_plantuml_simple_url/2","title":"SayCheezEx.Graphs.Plantuml.as_plantuml_simple_url/2","type":"function"},{"doc":"","ref":"SayCheezEx.Graphs.Plantuml.html#as_plantuml_url/2","title":"SayCheezEx.Graphs.Plantuml.as_plantuml_url/2","type":"function"},{"doc":"","ref":"SayCheezEx.Graphs.Plantuml.html#encode_byte/1","title":"SayCheezEx.Graphs.Plantuml.encode_byte/1","type":"function"},{"doc":"curl - oxxx . svg http :// www . plantuml . com / plantuml / svg / ~ h407374617274756d6c0a416c6963652d3e426f62203a204920616d207573696e67206865780a40656e64756d6c","ref":"SayCheezEx.Graphs.Plantuml.html#generate_content/1","title":"SayCheezEx.Graphs.Plantuml.generate_content/1","type":"function"},{"doc":"curl - oxxx . svg http :// www . plantuml . com / plantuml / svg / ~ h407374617274756d6c0a416c6963652d3e426f62203a204920616d207573696e67206865780a40656e64756d6c","ref":"SayCheezEx.Graphs.Plantuml.html#generate_content_plantuml_http/1","title":"SayCheezEx.Graphs.Plantuml.generate_content_plantuml_http/1","type":"function"},{"doc":"Should be possible without external dependencies https://stackoverflow.com/questions/8742169/how-can-i-compress-a-list-with-zlib-in-erlang-and-decompress-it-back","ref":"SayCheezEx.Graphs.Plantuml.html#make_plantuml_url_deflated/1","title":"SayCheezEx.Graphs.Plantuml.make_plantuml_url_deflated/1","type":"function"},{"doc":"PlantUML allows simple encoding - makes URLs very long, but it's trivial to implement as described in https://plantuml.com/text-encoding One can play along with different test cases with the online editor at https://www.plantuml.com/plantuml/uml/~h407374617274756d6c0a416c6963652d3e426f62203a204920616d207573696e67206865780a40656e64756d6c E.g. https://www.plantuml.com/plantuml/svg/~h407374617274756d6c0a416c6963652d3e426f62203a204920616d207573696e67206865780a40656e64756d6c The text does not require the startuml / enduml tags. Examples: iex&gt; Plantuml . make_plantuml_url_simple ( &quot;SayCheezEx -&gt; You : Elixir rocks&quot; ) &quot;https://www.plantuml.com/plantuml/svg/~h536179436865657A4578202D3E20596F75203A20456C6978697220726F636B73&quot;","ref":"SayCheezEx.Graphs.Plantuml.html#make_plantuml_url_simple/1","title":"SayCheezEx.Graphs.Plantuml.make_plantuml_url_simple/1","type":"function"},{"doc":"The interface for a graph provider. checks if a such a provider is available, given the providers' own configuration renders a graph to some HTML that can be embedded","ref":"SayCheezEx.Graphs.Provider.html","title":"SayCheezEx.Graphs.Provider","type":"behaviour"},{"doc":"Checks whether we have a file in our cache. If we do, we return its contents.","ref":"SayCheezEx.Graphs.Provider.html#cached?/2","title":"SayCheezEx.Graphs.Provider.cached?/2","type":"function"},{"doc":"Generates a file name for a tuple (module, recipe).","ref":"SayCheezEx.Graphs.Provider.html#cached_filename/2","title":"SayCheezEx.Graphs.Provider.cached_filename/2","type":"function"},{"doc":"We want to simplify the SVG that Graphviz generates so we can embed it in our HTML.","ref":"SayCheezEx.Graphs.Provider.html#clean_up_svg/1","title":"SayCheezEx.Graphs.Provider.clean_up_svg/1","type":"function"},{"doc":"Formats the error message, if any.","ref":"SayCheezEx.Graphs.Provider.html#display/1","title":"SayCheezEx.Graphs.Provider.display/1","type":"function"},{"doc":"Creates a file name for a temporary file. Ths may be a cache file or a proper temporary file. If you need mode than one file, you should encode it in the extensions.","ref":"SayCheezEx.Graphs.Provider.html#file/3","title":"SayCheezEx.Graphs.Provider.file/3","type":"function"},{"doc":"Given a recipe recipe for a graph, first tries a cache and then call a &quot;builder&quot; function to create it. So if the SVG was already generated, we load it from disk - if not, we build it again. Builder It returns {:ok, svg_text} or {:error, reason} that will be used to display a result.","ref":"SayCheezEx.Graphs.Provider.html#rebuild_if_needed/3","title":"SayCheezEx.Graphs.Provider.rebuild_if_needed/3","type":"function"},{"doc":"","ref":"SayCheezEx.Graphs.Provider.html#c:render/1","title":"SayCheezEx.Graphs.Provider.render/1","type":"callback"},{"doc":"","ref":"SayCheezEx.Graphs.Provider.html#c:render!/1","title":"SayCheezEx.Graphs.Provider.render!/1","type":"callback"},{"doc":"Runs an external command. It returns a binary that captures STDOUT+STDERR if all went well, or a tuple {:error, e} if something went bonkers. If it's trying to call a command that does not exist on your local environment, returns {:error, :cmd_not_found} .","ref":"SayCheezEx.Graphs.Provider.html#run_cmd/2","title":"SayCheezEx.Graphs.Provider.run_cmd/2","type":"function"},{"doc":"Computes a printable SHA for a string.","ref":"SayCheezEx.Graphs.Provider.html#string_hash/1","title":"SayCheezEx.Graphs.Provider.string_hash/1","type":"function"},{"doc":"The only significant advantage of this HTTP client is that it only uses things that are in Erlang itself. https://stackoverflow.com/questions/20108421/using-the-httpc-erlang-module-from-elixir","ref":"SayCheezEx.Graphs.Provider.html#trivial_http_get_client/1","title":"SayCheezEx.Graphs.Provider.trivial_http_get_client/1","type":"function"},{"doc":"Earmark says that &quot;A HTML Block defined by a tag starting a line and the same tag starting a different line is parsed as one HTML AST node, marked with %{verbatim: true}&quot; (see https://hexdocs.pm/earmark_parser/EarmarkParser.html ) So we wrap everything in a DIV and call it a day.","ref":"SayCheezEx.Graphs.Provider.html#wrap_in_div_for_valid_markdown/1","title":"SayCheezEx.Graphs.Provider.wrap_in_div_for_valid_markdown/1","type":"function"},{"doc":"Write a file to its right cache.","ref":"SayCheezEx.Graphs.Provider.html#write_to_cache/3","title":"SayCheezEx.Graphs.Provider.write_to_cache/3","type":"function"},{"doc":"Captures a snapshot of the environment at build time, so you can display it at run-time. And has a handy syntax to include UML graphs in your ExDocs. Sometimes you want to reference the version of your Elixir project at run time, or when / where / from what sources it was built, but that information is not available anymore once you deploy your app somewhere else. It could be in git , or in mix , or exposed as an Erlang system property... good luck remembering it all. With SayCheezEx, it's all in one place. They say that in Elixir, documentation is a first-class citizen. I find that UML graphs are very useful to document GenServers and their interactions. Now you can write them right into your @doc/@moduledoc texts. This library takes inspiration from an earlier Clojure library, which you can find at https://github.com/l3nz/say-cheez . The previous library has been very useful to me over the years, and I'm hoping that this one will be just as helpful!","ref":"readme.html","title":"SayCheezEx 📸","type":"extras"},{"doc":"Embedding build information Whenever you want to reference a version/build information, create an Elixir attribute for the module and compute its value through SayCheezEx. I often compute a &quot;short&quot; version number, an User-Agent for performing HTTP requests, and a full version that contains the full build information. For example: module Foo.Bar do import SayCheezEx , only : [ cheez! : 1 ] # Create all attributes we need: # ...a version string # &quot;v 0.1.5/d9a87c3 137 on server.local&quot; @version cheez! ( &quot;v {:project_version}/{:git_commit_id} {:build_number} on {:build_on}&quot; ) # ...a longer version string, with build ane Erlang information # &quot;0.1.5 d9a87c3/230411.1227 B:137/230411.1434/prod Ex:1.14.3/OTP25&quot; @version_full cheez! ( &quot;{:project_version} {:git_all} B:{:build_number,=-}/{:build_at}/{:build_mix_env} Ex:{:system}&quot; ) # ...an HTTP user-agent to be used by this module # &quot;Foo.Bar MyProject-0.1.5&quot; @user_agent cheez! ( &quot; \#{ __MODULE__ } {:project_name}-{:project_version}&quot; ) ... end Always make sure that you assign those values to an attibute - never call those functions directly . You can safely create such attributes in all modules that need them, as they are just one (usually very small) binary. Strings composed through cheez! will interpolate attributes between brackets, with the following rules: {:project_version} is an info tag. These is a long list of those - see below. {$HOST} is the environment variable HOST {=HELLO} is a default value, in this case the literal string &quot;HELLO&quot; If multiple attributes are specified, they all are expanded, and the first one that is defined will be output. So e.g. {$FOO,$BAR,=BAZ} will first try to interpolate the variable FOO; if that is undefined, it will try BAR, and if that too is undefined, it will output &quot;BAZ&quot; (that, being a default value, is always defined) They will also make sure that any module name embedded through __MODULE__ appears as it does in Elixir. What is available The name of this project, its version, the version of Elixir and OTP When the project was built, where was it built and by which user, the build number (if available) The current Git SHA that was built, when the last commit was made and by whom. A set of properties about the current BEAM VM (architecture, word size, etc.) The host name that this project was built on The mix environment that this project was built in (e.g. &quot;prod&quot; or &quot;dev&quot; or &quot;test&quot;) See https://hexdocs.pm/say_cheez_ex/SayCheezEx.html#info/1 for a full list. You can also call SayCheezEx.all() for a map with all available attributes: %{ build_at : &quot;230411.1538&quot; , build_at_day : &quot;2023-04-11&quot; , build_at_full : &quot;2023-04-11.15:38:40&quot; , build_by : &quot;lenz&quot; , build_number : &quot;87&quot; , build_on : &quot;MacBook-Pro.local&quot; , build_mix_env : &quot;dev&quot; , git_all : &quot;b204919/230411.1509&quot; , git_commit_id : &quot;b204919&quot; , git_commit_id_full : &quot;b2049190312ef810875476398978c2b0387251d3&quot; , git_date : &quot;2023-04-11.15:09:50&quot; , git_date_compact : &quot;230411.1509&quot; , git_last_committer : &quot;Lenz&quot; , project_full_version : &quot;0.2.1/b204919/230411.1509&quot; , project_name : &quot;SayCheezEx&quot; , project_version : &quot;0.2.1&quot; , sysinfo_arch : &quot;aarch64-apple-darwin22.3.0&quot; , sysinfo_banner : &quot;Erlang/OTP 25 [erts-13.2] [source] [64-bit] [smp:10:10] [ds:10:10:10] [async-threads:1] [jit]&quot; , sysinfo_beam : &quot;BEAM jit 13.2&quot; , sysinfo_c_compiler : &quot;gnuc 4.2.1&quot; , sysinfo_compat : &quot;25&quot; , sysinfo_driver : &quot;3.3&quot; , sysinfo_nif : &quot;2.16&quot; , sysinfo_ptr : &quot;64bit&quot; , sysinfo_word : &quot;64bit&quot; , system : &quot;1.14.3/OTP25&quot; , system_elixir : &quot;1.14.3&quot; , system_otp : &quot;25&quot; , ... . } UML/DOT Graphs You can now easily add graph created with GraphViz and PlantUML in your documentation. This is how they may look like: https://hexdocs.pm/say_cheez_ex/SayCheezEx.html#uml/1 At the moment, GraphViz needs to be installed, but PlantUML is computed through an online server. And graphs will be cached aggressively, so they are generated only once and won't slow down your developement cycle. Graphs will be embedded as SVG in your documentation, so they do not depend on client-side rendering, as it was the case with Mermaid.js. module Foo do import SayCheezEx , only : [ uml : 1 , graphviz : 1 ] @moduledoc &quot;&quot;&quot; Here goes a Graphviz graph: \#{ graphviz ( &quot;digraph { Sup -&gt; GenServ }&quot; ) } Here a PlantUML graph: \#{ uml ( &quot;&quot;&quot; Bob -&gt; Alice : I do love UML in documentation Alice -&gt; Bob : I love it as well! &quot;&quot;&quot; ) } &quot;&quot;&quot; ... end","ref":"readme.html#using","title":"SayCheezEx 📸 - Using","type":"extras"},{"doc":"Just add to your mix.exs file: { :say_cheez_ex , &quot;~&gt; 0.3&quot; } Full documentation: https://hexdocs.pm/say_cheez_ex Hex.pm: https://hex.pm/packages/say_cheez_ex","ref":"readme.html#installing","title":"SayCheezEx 📸 - Installing","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Foxes #33 - Include Erlang extra_applications for cleaner compile Fixes #21 - Tests check STDOUT when it is supposed to be written. Fixes #22 - You can control whether you want captured variables to appear on STDOUT or not. See the docs for SayCheez.cheez!/1 .","ref":"changelog.html#0-3-5-2023-09-02","title":"Changelog - 0.3.5 - 2023-09-02","type":"extras"},{"doc":"Fixes #26 - Document new SVG graphs with relevant examples - added some &quot;real life&quot; graphs Fixes #31 - Clean up SVG generated by PlantUML before embedding it. Fixes #28 - Handle errors in building graphs Fixes #27 - Enable caching under _build","ref":"changelog.html#0-3-3-2023-08-13","title":"Changelog - 0.3.3 - 2023-08-13","type":"extras"},{"doc":"Added initial support for Graphviz and PlantUML","ref":"changelog.html#0-3-1-2023-08-12","title":"Changelog - 0.3.1 - 2023-08-12","type":"extras"},{"doc":"Fixes #20 - Remove Elixir prefix from module names Fixes #18 - C Compiler attribute would not work on Windows. Thanks @milangupta1","ref":"changelog.html#0-2-3-2023-04-14","title":"Changelog - 0.2.3 - 2023.04.14","type":"extras"},{"doc":"Fixes #16 - major bug : cheez!() returned source string instead of expanded Fixes #15 - Capture mix.env Fixes #13 - Compiled architecture and BEAM attributes","ref":"changelog.html#0-2-2-2023-04-11","title":"Changelog - 0.2.2 - 2023.04.11","type":"extras"},{"doc":"Separated functions cheez! and cheez , where the first one prints out on standard out the captured string (as to earmark the compile log) Improved documentation","ref":"changelog.html#0-2-1-2023-03-20","title":"Changelog - 0.2.1 - 2023.03.20","type":"extras"},{"doc":"NEW! Compact string format (fixes #14) Reading hostname (fixes #12)","ref":"changelog.html#0-2-0-2023-03-19","title":"Changelog - 0.2.0 - 2023.03.19","type":"extras"},{"doc":"Able to read the date from ancient versions of Git. (bug #7)","ref":"changelog.html#0-1-5-2023-03-09","title":"Changelog - 0.1.5 - 2023.03.09","type":"extras"},{"doc":"Fixed typos in documentation Added msg method Will now print missing variables on stdout Fixes #10 - Camelized project name Fixes #8 - Git: unknown date format","ref":"changelog.html#0-1-4-2023-02-15","title":"Changelog - 0.1.4 - 2023.02.15","type":"extras"},{"doc":"Improved documentation Added Credo and Dialyzer","ref":"changelog.html#0-1-3-2023-02-14","title":"Changelog - 0.1.3 - 2023.02.14","type":"extras"},{"doc":"First useful results.","ref":"changelog.html#0-1-1","title":"Changelog - 0.1.1","type":"extras"}]